﻿@page "/subsystem-compartment-detail/{PageModeName}"
@page "/subsystem-compartment-detail/{PageModeName}/{Id:int}"
@inject HttpClient HttpClient
@inject ISnackbar Snackbar
@inject NavigationManager NavigationManager

<PageTitle Title=@($"サブシステム区分詳細({pageMode.DisplayValue})") />

<EditForm Model="@subSystemCompartment" OnValidSubmit="OnValidSubmit" class="mt-2">
    <DataAnnotationsValidator />
    <MudCard>
        <MudCardContent>
            <MudItem xs="12" sm="6" md="4">
                <MudSelect Label="@subSystemCompartment.SystemCompartment.GetDisplayName(s => s.Compartment)"
                           T="int" @bind-Value="subSystemCompartment.SystemCompartmentId" ReadOnly="pageMode.IsReadOnly">
                    @foreach (var systemCompartment in systemCompartments)
                    {
                        <MudSelectItem Value="@(systemCompartment.Id)">@($"{systemCompartment.Compartment} {systemCompartment.CompartmentName}")</MudSelectItem>
                    }
                </MudSelect>
            </MudItem>
            <MudItem xs="12" sm="6" md="4">
                <MudTextField Label="@subSystemCompartment.GetDisplayName(s => s.Compartment)"
                              @bind-Value="subSystemCompartment.Compartment"
                              For="@(() => subSystemCompartment.Compartment)"
                              ReadOnly="pageMode.IsReadOnly"
                              HelperText="@subSystemCompartment.GetDisplayDescription(s => s.Compartment)" HelperTextOnFocus="true" />
            </MudItem>
            <MudItem xs="12" sm="6" md="4">
                <MudTextField Label="@subSystemCompartment.GetDisplayName(s => s.CompartmentName)"
                              @bind-Value="subSystemCompartment.CompartmentName"
                              For="@(() => subSystemCompartment.CompartmentName)"
                              ReadOnly="pageMode.IsReadOnly" />
            </MudItem>
            <MudItem xs="12" sm="6" md="4">
                <MudTextField Label="@subSystemCompartment.GetDisplayName(s => s.Description)"
                              @bind-Value="subSystemCompartment.Description"
                              For="@(() => subSystemCompartment.Description)"
                              Lines="3"
                              ReadOnly="pageMode.IsReadOnly" />
            </MudItem>
            <MudItem xs="12" sm="6" md="4">
                <MudTextField Label="@subSystemCompartment.GetDisplayName(s => s.Remarks)"
                              @bind-Value="subSystemCompartment.Remarks"
                              For="@(() => subSystemCompartment.Remarks)"
                              Lines="3"
                              ReadOnly="pageMode.IsReadOnly" />
            </MudItem>
        </MudCardContent>
        <MudCardActions>
            @if (!pageMode.Equals(PageMode.Show))
            {
                <MudButton ButtonType="ButtonType.Submit" Variant="Variant.Filled" Color="@(pageMode.Equals(PageMode.Delete) ? Color.Secondary : Color.Primary)" Class="mr-4">@pageMode.DisplayValue</MudButton>
            }
            <MudButton Variant="Variant.Filled" Link="/subsystem-compartment-list">戻る</MudButton>
        </MudCardActions>
    </MudCard>
</EditForm>

@code {
    [Parameter]
    public string PageModeName { get; set; }

    [Parameter]
    public int Id { get; set; }

    private PageMode pageMode = new(1);
    private SubSystemCompartmentEntity subSystemCompartment = new();
    private IEnumerable<SystemCompartmentEntity> systemCompartments = new List<SystemCompartmentEntity>();

    protected override void OnParametersSet()
    {
        pageMode = new(PageModeName);
    }

    protected async override Task OnInitializedAsync()
    {
        systemCompartments = await HttpClient.GetFromJsonAsync<List<SystemCompartmentEntity>>($"api/SystemCompartments");

        if (Id != 0)
        {
            try
            {
                subSystemCompartment = await HttpClient.GetFromJsonAsync<SubSystemCompartmentEntity>($"api/SubSystemCompartments/{Id}");
            }
            catch (Exception ex)
            {
                Snackbar.Add(ex.Message, Severity.Success);
            }
        }
    }

    private async Task OnValidSubmit(EditContext context)
    {
        try
        {
            if (pageMode == PageMode.Create)
            {
                await HttpClient.PostAsJsonAsync<SubSystemCompartmentEntity>("api/SubSystemCompartments", subSystemCompartment);
            }
            else if (pageMode == PageMode.Edit)
            {
                await HttpClient.PutAsJsonAsync<SubSystemCompartmentEntity>($"api/SubSystemCompartments/{Id}", subSystemCompartment);
            }
            else if (pageMode == PageMode.Delete)
            {
                await HttpClient.DeleteAsync($"api/SubSystemCompartments/{Id}");
            }
        }
        catch (Exception)
        {
            throw;
        }

        NavigationManager.NavigateTo("/subsystem-compartment-list");
        StateHasChanged();
    }
}